package org.projectopen.timesheet;

/*
 * Copyright (C) 2010 ]project-open[ 
 *
 * This program is free software. You can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2 of the License, or (at your option)
 * any later version. This program is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * @author Frank Bergmann (frank.bergmann@project-open.com)
 * 
 */

import java.util.Collections;
import java.util.Vector;
import org.w3c.dom.Element;


@SuppressWarnings("unchecked")

public class ProjopProject extends ProjopObject implements Comparable {
	
	private ProjopProject parentProject = null;
	private Vector childProjects = new Vector();
	
	 public ProjopProject() {
			super("im_project");
	}

	public ProjopProject getParent() {
		return parentProject;
	}

	public void setParent(ProjopProject parentProject) {
		this.parentProject = parentProject;
	}

	public void setChildProjects(Vector childProjects) {
		this.childProjects = childProjects;
	}

	public Vector getChildProjects() {
		
		Collections.sort(childProjects);
		return childProjects;
	}    
    	
	public String toString() {	
		String name = get("project_name");
		if (name == null) { name = super.toString(); }
		return name;
	}
	/*
	 * Create a mew Project from a list of MyTimesheetProjects:
	 * <row>
	 * 		<project_id>45624</project_id>
	 * 		<project_name>Big Customer Mailman Issue</project_name>
	 * 		<level>1</level>
	 * 		<project_type>Ticket</project_type>
	 * 		<project_status>Open</project_status>
	 * </row>
	 * Projects are ordered in such a way that a parent is always 
	 * returned before its children, so we can be sure that the lookup
	 * of the parent will be successful.
	 */
    public static ProjopProject projectFromMyTimesheetProjectsXML (Element el) {
		String projectName = getTextValue(el,"project_name");
		int projectId = getIntValue(el,"project_id");
		int level = getIntValue(el,"level");
		
		//Create a new Employee with the value read from the xml nodes
		ProjopProject p = new ProjopProject();
		p.setObjectId(projectId);
		p.set("project_id", projectId + "");
		p.set("project_name", projectName);
		p.set("level", level + "");
		
		return p;
    }

	public int compareTo(Object arg0) {
		String projectName = this.toString();
		return projectName.compareTo(arg0.toString());
	}

}
